<template>
  <q-field v-for="el in model" dense standout prefix="Доплата" class="mx-4">
    <template v-slot:prepend>
      <q-icon class="mt-2" name="attach_money"/>
    </template>
    <template v-slot:control>
      <q-input
          v-model="el.date"
          :model-value="el.date"
          input-class="text-right w-12"
          @update:model-value="useDebounce"
          :loading="loading"
          class="mr-1 ml-auto"
          placeholder="Дата"
      />
      <q-input
          v-model="el.value"
          :model-value="el.value"
          input-class="text-right w-12"
          class="mr-1"
          @update:model-value="useDebounce"
          :loading="loading"
          placeholder="Сумма"
      />
      <q-input
          v-model="el.date_2"
          :model-value="el.date_2"
          input-class="text-right w-12"
          @update:model-value="useDebounce"
          :loading="loading"
          class=""
          placeholder="Дата"
      />
    </template>
  </q-field>
</template>

<script>
import {ref} from "vue";
import {useDebounce} from "../../components/useDebounce";
import {useUpdateLead} from "../../components/useUpdateLead";

export default {
  name: "add_pay",
  props: {
    model: { type: Array, default: [] },
    _id: { type: String, default: '' }
  },
  emits: ['update-field'],
  setup (prop, {emit}) {
    const loading = ref()

    return {
      loading,
      useDebounce: useDebounce(async function () {
        loading.value = true
        const payload = {_id: prop._id, key: 'add_pay', value: prop.model}
        useUpdateLead(payload)
          .then(() => {
            loading.value = false
            if (prop.model.length <= 1) emit('update-field', payload)
            if (prop.model[prop.model.length - 1].date.length || prop.model[prop.model.length - 1].value.length) prop.model.push({date: '', value: '', date_2: ''})
          })
      }, 800),
    }
  }
}
</script>

<style scoped>

</style>